import React, { FC, ReactElement } from 'react';
import { Placement } from 'rdk';
import { SelectInput, SelectInputProps } from './SelectInput';
import { SelectMenu, SelectMenuProps } from './SelectMenu';
import { SelectOptionProps } from './SelectOption';
export interface SelectProps {
    id?: string;
    name?: string;
    style?: React.CSSProperties;
    className?: string;
    disabled?: boolean;
    autoFocus?: boolean;
    closeOnSelect?: boolean;
    value?: string | string[];
    required?: boolean;
    multiple?: boolean;
    placeholder?: string;
    filterable?: boolean;
    clearable?: boolean;
    loading?: boolean;
    refreshable?: boolean;
    createable?: boolean;
    children?: any;
    error?: boolean;
    menuPlacement?: Placement;
    menuDisabled?: boolean;
    onInputKeydown?: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    onInputKeyUp?: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    onFocus?: (event: React.FocusEvent<HTMLInputElement> | React.MouseEvent<HTMLDivElement>) => void;
    onBlur?: (event: React.FocusEvent<HTMLInputElement>) => void;
    onInputChange?: (event: React.ChangeEvent<HTMLInputElement>) => void;
    onRefresh?: () => void;
    onChange?: (value: any) => void;
    onOptionsChange?: (options: SelectOptionProps[]) => void;
    input?: ReactElement<SelectInputProps, typeof SelectInput>;
    menu?: ReactElement<SelectMenuProps, typeof SelectMenu>;
}
export declare const Select: FC<Partial<SelectProps>>;
