(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react/jsx-runtime'), require('react'), require('rdk'), require('classnames'), require('react-input-autosize'), require('framer-motion'), require('ellipsize'), require('react-highlight-words'), require('react-use-fuzzy'), require('lodash/groupBy'), require('lodash/sumBy'), require('react-fast-compare')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react/jsx-runtime', 'react', 'rdk', 'classnames', 'react-input-autosize', 'framer-motion', 'ellipsize', 'react-highlight-words', 'react-use-fuzzy', 'lodash/groupBy', 'lodash/sumBy', 'react-fast-compare'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.reaselect = {}, global.jsxRuntime, global.react, global.rdk, global.classNames, global.AutosizeInput, global.framerMotion, global.ellipsize, global.Highlighter, global.reactUseFuzzy, global.groupBy, global.sumBy, global.isEqual));
})(this, (function (exports, jsxRuntime, react, rdk, classNames, AutosizeInput, framerMotion, ellipsize, Highlighter, reactUseFuzzy, groupBy, sumBy, isEqual) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
  var AutosizeInput__default = /*#__PURE__*/_interopDefaultLegacy(AutosizeInput);
  var ellipsize__default = /*#__PURE__*/_interopDefaultLegacy(ellipsize);
  var Highlighter__default = /*#__PURE__*/_interopDefaultLegacy(Highlighter);
  var groupBy__default = /*#__PURE__*/_interopDefaultLegacy(groupBy);
  var sumBy__default = /*#__PURE__*/_interopDefaultLegacy(sumBy);
  var isEqual__default = /*#__PURE__*/_interopDefaultLegacy(isEqual);

  const DownArrowIcon = () => (jsxRuntime.jsx("svg", Object.assign({ xmlns: "http://www.w3.org/2000/svg", x: "0px", y: "0px", width: "50", height: "50", viewBox: "0 0 32 32" }, { children: jsxRuntime.jsx("path", { d: "M 4.21875 10.78125 L 2.78125 12.21875 L 15.28125 24.71875 L 16 25.40625 L 16.71875 24.71875 L 29.21875 12.21875 L 27.78125 10.78125 L 16 22.5625 Z" }, void 0) }), void 0));

  const CloseIcon = () => (jsxRuntime.jsx("svg", Object.assign({ xmlns: "http://www.w3.org/2000/svg", x: "0px", y: "0px", width: "32", height: "32", viewBox: "0 0 32 32" }, { children: jsxRuntime.jsx("path", { d: "M 7.21875 5.78125 L 5.78125 7.21875 L 14.5625 16 L 5.78125 24.78125 L 7.21875 26.21875 L 16 17.4375 L 24.78125 26.21875 L 26.21875 24.78125 L 17.4375 16 L 26.21875 7.21875 L 24.78125 5.78125 L 16 14.5625 Z" }, void 0) }), void 0));

  const SPEED = 0.2;
  const LoadingIcon = () => (jsxRuntime.jsx(react.Fragment, { children: [...Array(3)].map((_, i) => (jsxRuntime.jsx(framerMotion.motion.div, { animate: {
              opacity: [0, 1, 0],
              scale: [1, 2, 2, 1, 1]
          }, transition: {
              duration: SPEED * 4,
              ease: 'easeInOut',
              times: [0, 0.2, 0.5, 0.8, 1],
              loop: Infinity,
              repeatDelay: SPEED,
              delay: SPEED * i
          } }, i))) }, void 0));

  const RefreshIcon = () => (jsxRuntime.jsx("svg", Object.assign({ xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 32 32", width: "64px", height: "64px" }, { children: jsxRuntime.jsx("path", { d: "M 16 4 C 10.886719 4 6.617188 7.160156 4.875 11.625 L 6.71875 12.375 C 8.175781 8.640625 11.710938 6 16 6 C 19.242188 6 22.132813 7.589844 23.9375 10 L 20 10 L 20 12 L 27 12 L 27 5 L 25 5 L 25 8.09375 C 22.808594 5.582031 19.570313 4 16 4 Z M 25.28125 19.625 C 23.824219 23.359375 20.289063 26 16 26 C 12.722656 26 9.84375 24.386719 8.03125 22 L 12 22 L 12 20 L 5 20 L 5 27 L 7 27 L 7 23.90625 C 9.1875 26.386719 12.394531 28 16 28 C 21.113281 28 25.382813 24.839844 27.125 20.375 Z" }, void 0) }), void 0));

  function styleInject(css, ref) {
    if ( ref === void 0 ) ref = {};
    var insertAt = ref.insertAt;

    if (!css || typeof document === 'undefined') { return; }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css_248z$2 = ".SelectInputChip-module_tag__jTRBu {\n  margin-top: 2px;\n  margin-bottom: 2px;\n  border: solid 1px transparent;\n  cursor: pointer;\n  background: var(--color-select-chip);\n  border: solid 1px var(--color-select-chip-border);\n  color: var(--color-on-select-chip);\n  display: flex;\n  padding: 2px 4px;\n  margin-right: 4px;\n  font-size: 12px;\n  border-radius: 4px;\n}\n\n  .SelectInputChip-module_tag__jTRBu.SelectInputChip-module_disabled__16r59 {\n    cursor: not-allowed;\n  }\n\n  .SelectInputChip-module_tag__jTRBu:focus {\n    border: solid 1px transparent;\n  }\n\n  .SelectInputChip-module_tag__jTRBu button {\n    cursor: pointer;\n    background: none;\n    border: none;\n    line-height: 0;\n    padding: 0;\n    margin-left: 4px;\n  }\n\n  .SelectInputChip-module_tag__jTRBu:focus {\n    outline: none;\n  }\n\n  .SelectInputChip-module_tag__jTRBu svg {\n    height: 12px;\n    width: 12px;\n    vertical-align: baseline;\n    pointer-events: none;\n    fill: var(--color-select-chip-icon);\n  }\n";
  var css$2 = {"tag":"SelectInputChip-module_tag__jTRBu","disabled":"SelectInputChip-module_disabled__16r59"};
  styleInject(css_248z$2);

  const SelectInputChip = ({ option, disabled, clearable, className, maxLength, closeIcon, onTagKeyDown, onSelectedChange }) => {
      const origLabel = option.inputLabel || option.children;
      const label = typeof origLabel === 'string' ? ellipsize__default["default"](origLabel, maxLength) : origLabel;
      return (jsxRuntime.jsxs("span", Object.assign({ className: classNames__default["default"](css$2.tag, className, 'reaselct-input-chip'), title: origLabel, tabIndex: -1, onKeyDown: event => onTagKeyDown(event, option) }, { children: [label, !disabled && clearable && (jsxRuntime.jsx("button", Object.assign({ type: "button", onClick: () => onSelectedChange(option) }, { children: closeIcon }), void 0))] }), void 0));
  };
  SelectInputChip.defaultProps = {
      closeIcon: jsxRuntime.jsx(CloseIcon, {}, void 0),
      maxLength: 20
  };

  var css_248z$1 = ".SelectInput-module_container__1RpWr {\n  display: flex;\n  flex-wrap: nowrap;\n  background: var(--color-select-input);\n  border-radius: var(--select-border-radius);\n  border: solid 1px var(--color-select-input-border);\n  align-items: center;\n  padding: 0 12px;\n  min-height: 38px;\n}\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_open__349Ai {\n    border-radius: var(--select-border-radius) var(--select-border-radius) 0 0;\n  }\n\n  .SelectInput-module_container__1RpWr:not(.SelectInput-module_disabled__1iHEo) {\n    cursor: text;\n  }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_disabled__1iHEo .SelectInput-module_expand__2rUY7,\n    .SelectInput-module_container__1RpWr.SelectInput-module_disabled__1iHEo .SelectInput-module_input__ib6_X {\n      cursor: not-allowed;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_unfilterable__1CBOr .SelectInput-module_input__ib6_X {\n      caret-color: transparent;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_error__1Uu03 {\n    border: 1px solid var(--color-select-input-error);\n  }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_inputContainer__1BHRg {\n    display: flex;\n    flex: 1;\n    align-items: center;\n    overflow: hidden;\n  }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X {\n    padding: 0;\n    background: transparent;\n    border: none;\n    font-size: 13px;\n    color: var(--color-on-select-input);\n    font-family: inherit;\n    vertical-align: middle;\n  }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X[disabled] {\n      color: var(--color-select-input-disabled);\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X::-moz-placeholder {\n      color: var(--color-select-input-placeholder);\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X:-ms-input-placeholder {\n      color: var(--color-select-input-placeholder);\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X::placeholder {\n      color: var(--color-select-input-placeholder);\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X:focus {\n      outline: none;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X:-moz-read-only {\n      cursor: not-allowed;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_input__ib6_X:read-only {\n      cursor: not-allowed;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_single__1KuWP .SelectInput-module_prefix__uL_kt {\n      padding: 5px 0;\n      overflow: hidden;\n      white-space: nowrap;\n      text-overflow: ellipsis;\n      max-width: 100%;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_single__1KuWP .SelectInput-module_inputContainer__1BHRg {\n      flex-wrap: nowrap;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_single__1KuWP .SelectInput-module_inputContainer__1BHRg > div,\n      .SelectInput-module_container__1RpWr.SelectInput-module_single__1KuWP .SelectInput-module_inputContainer__1BHRg .SelectInput-module_input__ib6_X {\n        max-width: 100%;\n      }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_single__1KuWP .SelectInput-module_input__ib6_X {\n      width: 100%;\n      text-overflow: ellipsis;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_multiple__3pCzu .SelectInput-module_prefix__uL_kt {\n      display: contents;\n    }\n\n  .SelectInput-module_container__1RpWr.SelectInput-module_multiple__3pCzu .SelectInput-module_inputContainer__1BHRg {\n      flex-wrap: wrap;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_prefix__uL_kt {\n    align-items: center;\n  }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH {\n    display: flex;\n    margin-left: auto;\n  }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH svg {\n      height: 20px;\n      width: 20px;\n      vertical-align: middle;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_loader__JUJCb {\n      display: flex;\n      align-items: center;\n      margin-right: 10px;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_loader__JUJCb div {\n        margin-left: 10px;\n        border-radius: 50%;\n        height: 2px;\n        width: 2px;\n        background: var(--color-select-input-icon);\n      }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth {\n      padding: 0;\n      border: none;\n      background: none;\n    }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth:not([disabled]) {\n        cursor: pointer;\n      }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth svg {\n        vertical-align: middle;\n        fill: var(--color-select-input-icon);\n      }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth.SelectInput-module_expand__2rUY7 svg {\n          height: 18px;\n          width: 18px;\n        }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth.SelectInput-module_refresh__2XpXz,\n      .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth.SelectInput-module_close__1qMUI {\n        margin-right: 5px;\n      }\n\n  .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth.SelectInput-module_refresh__2XpXz svg, .SelectInput-module_container__1RpWr .SelectInput-module_suffix__1FaXH .SelectInput-module_btn__2isth.SelectInput-module_close__1qMUI svg {\n          height: 16px;\n          width: 16px;\n        }\n";
  var css$1 = {"container":"SelectInput-module_container__1RpWr","open":"SelectInput-module_open__349Ai","disabled":"SelectInput-module_disabled__1iHEo","expand":"SelectInput-module_expand__2rUY7","input":"SelectInput-module_input__ib6_X","unfilterable":"SelectInput-module_unfilterable__1CBOr","error":"SelectInput-module_error__1Uu03","inputContainer":"SelectInput-module_inputContainer__1BHRg","single":"SelectInput-module_single__1KuWP","prefix":"SelectInput-module_prefix__uL_kt","multiple":"SelectInput-module_multiple__3pCzu","suffix":"SelectInput-module_suffix__1FaXH","loader":"SelectInput-module_loader__JUJCb","btn":"SelectInput-module_btn__2isth","refresh":"SelectInput-module_refresh__2XpXz","close":"SelectInput-module_close__1qMUI"};
  styleInject(css_248z$1);

  const horiztonalArrowKeys = ['ArrowLeft', 'ArrowRight'];
  const verticalArrowKeys = ['ArrowUp', 'ArrowDown'];
  const actionKeys = [...verticalArrowKeys, 'Enter', 'Tab', 'Escape'];
  const SelectInput = ({ reference, autoFocus, selectedOption, disabled, placeholder, filterable, fontSize, id, name, className, inputText, required, loading, clearable, multiple, refreshable, error, menuDisabled, menuOpen, refreshIcon, closeIcon, expandIcon, loadingIcon, closeOnSelect, onSelectedChange, onKeyDown, onKeyUp, onExpandClick, onInputChange, onFocus, onBlur, onRefresh, chip }) => {
      var _a;
      const containerRef = react.useRef(null);
      const inputRef = react.useRef(null);
      const hasValue = (multiple && ((_a = selectedOption) === null || _a === void 0 ? void 0 : _a.length) > 0) ||
          (!multiple && selectedOption);
      const placeholderText = hasValue ? '' : placeholder;
      const showClear = clearable && !disabled && hasValue;
      react.useImperativeHandle(reference, () => ({
          containerRef,
          inputRef,
          focus: () => focusInput()
      }));
      const inputTextValue = react.useMemo(() => {
          if (!inputText && hasValue) {
              if (!Array.isArray(selectedOption)) {
                  const singleOption = selectedOption;
                  if (!singleOption.inputLabel) {
                      return singleOption.children;
                  }
              }
              return '';
          }
          return inputText;
      }, [hasValue, inputText, selectedOption]);
      const onClearValues = react.useCallback((event) => {
          // Stop propogation to prevent closing the menu
          if (closeOnSelect) {
              event.stopPropagation();
          }
          onSelectedChange(null);
      }, [onSelectedChange, closeOnSelect]);
      const focusInput = react.useCallback(() => {
          const input = inputRef.current;
          if (input) {
              if (input.value) {
                  const len = input.value.length;
                  // Handle dom settle
                  setTimeout(() => input.setSelectionRange(len, len));
                  input.focus();
              }
              else {
                  input.focus();
              }
          }
      }, []);
      const onInputFocus = react.useCallback((event) => {
          // On initial focus, move focus to the last character of the value
          if (!multiple && filterable && selectedOption) {
              // We are handling the selection ourself
              event.preventDefault();
              // Stop parent container click event from double firing
              event.stopPropagation();
              focusInput();
          }
          onFocus === null || onFocus === void 0 ? void 0 : onFocus(event);
      }, [filterable, focusInput, multiple, onFocus, selectedOption]);
      const onContainerClick = react.useCallback((event) => {
          if (!disabled) {
              focusInput();
          }
      }, [disabled, focusInput]);
      const removeLastValue = react.useCallback(() => {
          if (multiple) {
              const selectedOptions = selectedOption;
              onSelectedChange(selectedOptions[selectedOptions.length - 1]);
          }
          else {
              onSelectedChange(null);
          }
      }, [multiple, onSelectedChange, selectedOption]);
      const onInputKeyDown = react.useCallback((event) => {
          const key = event.key;
          const isActionKey = actionKeys.includes(key);
          if (isActionKey) {
              event.preventDefault();
              event.stopPropagation();
          }
          if (clearable && key === 'Backspace' && hasValue) {
              if (!multiple || (multiple && !inputText)) {
                  event.preventDefault();
                  event.stopPropagation();
                  removeLastValue();
              }
          }
          onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(event);
      }, [clearable, hasValue, inputText, multiple, onKeyDown, removeLastValue]);
      const onInputKeyUp = react.useCallback((event) => {
          const key = event.key;
          const isActionKey = actionKeys.includes(key);
          const isHorzKey = horiztonalArrowKeys.includes(key);
          if ((!filterable && !isActionKey) || isHorzKey) {
              event.preventDefault();
              event.stopPropagation();
          }
          else {
              onKeyUp === null || onKeyUp === void 0 ? void 0 : onKeyUp(event);
          }
      }, [filterable, onKeyUp]);
      const onChange = react.useCallback((event) => {
          if (filterable) {
              onInputChange(event);
          }
      }, [filterable, onInputChange]);
      const onTagKeyDown = react.useCallback((event, option) => {
          const key = event.key;
          if (key === 'Backspace' && !disabled && clearable) {
              onSelectedChange(option);
          }
      }, [clearable, disabled, onSelectedChange]);
      const renderPrefix = react.useCallback(() => {
          if (multiple) {
              const multipleOptions = selectedOption;
              if (multipleOptions === null || multipleOptions === void 0 ? void 0 : multipleOptions.length) {
                  return (jsxRuntime.jsx("div", Object.assign({ className: classNames__default["default"](css$1.prefix, 'reaselct-input-value') }, { children: multipleOptions.map(option => (jsxRuntime.jsx(rdk.CloneElement, { element: chip, option: option, clearable: clearable, disabled: disabled, closeIcon: closeIcon, onSelectedChange: onSelectedChange, onTagKeyDown: onTagKeyDown }, option.value))) }), void 0));
              }
          }
          else {
              const singleOption = selectedOption;
              if ((singleOption === null || singleOption === void 0 ? void 0 : singleOption.inputLabel) && !inputText) {
                  return (jsxRuntime.jsx("div", Object.assign({ className: classNames__default["default"](css$1.prefix, 'reaselct-input-value') }, { children: singleOption === null || singleOption === void 0 ? void 0 : singleOption.inputLabel }), void 0));
              }
          }
          return null;
      }, [
          chip,
          clearable,
          closeIcon,
          disabled,
          inputText,
          multiple,
          onSelectedChange,
          onTagKeyDown,
          selectedOption
      ]);
      return (jsxRuntime.jsxs("div", Object.assign({ ref: containerRef, className: classNames__default["default"](css$1.container, 'reaselct-input', className, {
              [css$1.disabled]: disabled,
              [css$1.unfilterable]: !filterable,
              [css$1.error]: error,
              [css$1.single]: !multiple,
              [css$1.multiple]: multiple,
              [css$1.open]: menuOpen
          }), onClick: onContainerClick }, { children: [jsxRuntime.jsxs("div", Object.assign({ className: css$1.inputContainer, onClick: onInputFocus }, { children: [renderPrefix(), jsxRuntime.jsx(AutosizeInput__default["default"], { inputRef: el => (inputRef.current = el), id: id, style: { fontSize }, name: name, disabled: disabled, required: required, autoFocus: autoFocus, placeholder: placeholderText, inputClassName: classNames__default["default"](css$1.input, 'reaselct-input-input'), value: inputTextValue, autoCorrect: "off", spellCheck: "false", autoComplete: "off", onKeyDown: onInputKeyDown, onKeyUp: onInputKeyUp, onChange: onChange, onFocus: onInputFocus, onBlur: onBlur }, void 0)] }), void 0), jsxRuntime.jsxs("div", Object.assign({ className: css$1.suffix }, { children: [refreshable && !loading && (jsxRuntime.jsx("button", Object.assign({ type: "button", title: "Refresh Options", disabled: disabled, className: classNames__default["default"](css$1.refresh, css$1.btn, 'reaselct-input-refresh'), onClick: onRefresh }, { children: refreshIcon }), void 0)), loading && jsxRuntime.jsx("div", Object.assign({ className: css$1.loader }, { children: loadingIcon }), void 0), showClear && (jsxRuntime.jsx("button", Object.assign({ type: "button", title: "Clear selection", disabled: disabled, className: classNames__default["default"](css$1.close, css$1.btn, 'reaselct-input-clear'), onClick: onClearValues }, { children: closeIcon }), void 0)), !menuDisabled && (jsxRuntime.jsx("button", Object.assign({ type: "button", title: "Toggle options menu", disabled: disabled, className: classNames__default["default"](css$1.expand, css$1.btn, 'reaselct-input-toggle'), onClick: onExpandClick }, { children: expandIcon }), void 0))] }), void 0)] }), void 0));
  };
  SelectInput.defaultProps = {
      fontSize: 13,
      expandIcon: jsxRuntime.jsx(DownArrowIcon, {}, void 0),
      closeIcon: jsxRuntime.jsx(CloseIcon, {}, void 0),
      refreshIcon: jsxRuntime.jsx(RefreshIcon, {}, void 0),
      loadingIcon: jsxRuntime.jsx(LoadingIcon, {}, void 0),
      chip: jsxRuntime.jsx(SelectInputChip, {}, void 0)
  };

  var css_248z = ".SelectMenu-module_menu__I2a4- {\n  background: var(--color-select-menu);\n  text-align: center;\n  will-change: transform, opacity;\n  border-radius: 0 0 var(--select-border-radius) var(--select-border-radius);\n  min-width: 112px;\n  max-height: 300px;\n  overflow-y: auto;\n  text-align: left;\n  border: solid 1px var(--color-select-menu-border);\n  border-top: none;\n}\n\n  .SelectMenu-module_menu__I2a4- ul,\n  .SelectMenu-module_menu__I2a4- li {\n    list-style: none;\n  }\n\n  .SelectMenu-module_menu__I2a4- ul {\n    padding: 0;\n    margin: 0;\n  }\n\n  .SelectMenu-module_menu__I2a4- li {\n    padding: 7px 10px;\n  }\n\n  .SelectMenu-module_menu__I2a4- li:not(.SelectMenu-module_disabled__1rE6k) {\n      color: pointer;\n    }\n\n  .SelectMenu-module_menu__I2a4- .SelectMenu-module_groupItem__hBxeJ {\n    border: none;\n    padding: 0;\n  }\n\n  .SelectMenu-module_menu__I2a4- .SelectMenu-module_groupItem__hBxeJ h3 {\n      font-size: 12px;\n      margin: 0;\n      font-weight: bold;\n      text-transform: uppercase;\n      padding: 10px 0 5px 10px;\n      color: var(--color-select-menu-group);\n    }\n\n  .SelectMenu-module_menu__I2a4- .SelectMenu-module_option__3Ns1t {\n    border: none;\n    color: var(--color-on-select-menu-item);\n    font-size: 14px;\n    cursor: pointer;\n  }\n\n  .SelectMenu-module_menu__I2a4- .SelectMenu-module_option__3Ns1t:hover,\n    .SelectMenu-module_menu__I2a4- .SelectMenu-module_option__3Ns1t.SelectMenu-module_active__fcJSN {\n      color: var(--color-on-select-menu-item-active);\n      background: var(--color-select-menu-item-active);\n    }\n\n  .SelectMenu-module_menu__I2a4- .SelectMenu-module_option__3Ns1t.SelectMenu-module_selected__1LTVS {\n      color: var(--color-on-select-menu-item-selected);\n      background: var(--color-select-menu-item-selected);\n    }\n";
  var css = {"menu":"SelectMenu-module_menu__I2a4-","disabled":"SelectMenu-module_disabled__1rE6k","groupItem":"SelectMenu-module_groupItem__hBxeJ","option":"SelectMenu-module_option__3Ns1t","active":"SelectMenu-module_active__fcJSN","selected":"SelectMenu-module_selected__1LTVS"};
  styleInject(css_248z);

  const SelectMenu = ({ style, disabled, createable, selectedOption, options, loading, className, index, filterable, groups, multiple, inputSearchText, onSelectedChange }) => {
      const trimmedText = inputSearchText.trim();
      const checkOptionSelected = react.useCallback((option) => {
          var _a;
          if (multiple) {
              if (Array.isArray(selectedOption)) {
                  return selectedOption.find(o => o.value === option.value);
              }
              return false;
          }
          return ((_a = selectedOption) === null || _a === void 0 ? void 0 : _a.value) === option.value;
      }, [selectedOption, multiple]);
      const renderListItems = react.useCallback((items, group) => items.map((o, i) => (jsxRuntime.jsx("li", Object.assign({ className: classNames__default["default"](css.option, 'reaselct-menu-item', {
              [css.selected]: checkOptionSelected(o),
              [css.active]: index === i + ((group === null || group === void 0 ? void 0 : group.offset) || 0),
              [css.diabled]: disabled || o.disabled
          }), onClick: event => {
              event.preventDefault();
              event.stopPropagation();
              onSelectedChange(o);
          } }, { children: o.menuLabel ? (o.menuLabel) : (jsxRuntime.jsx(Highlighter__default["default"], { searchWords: [inputSearchText], autoEscape: true, textToHighlight: o.children }, void 0)) }), `${group === null || group === void 0 ? void 0 : group.name}-${o.value}`))), [checkOptionSelected, disabled, index, inputSearchText, onSelectedChange]);
      return (jsxRuntime.jsx(framerMotion.motion.div, Object.assign({ style: style, className: classNames__default["default"](css.menu, className, 'reaselct-menu'), initial: {
              opacity: 0,
              y: -20,
              pointerEvents: 'none'
          }, animate: {
              opacity: 1,
              y: 0,
              pointerEvents: 'auto',
              transition: {
                  when: 'beforeChildren'
              }
          }, exit: {
              y: -14,
              opacity: 0,
              pointerEvents: 'none',
              transition: { duration: 0.3, ease: 'anticipate' }
          } }, { children: jsxRuntime.jsxs("ul", { children: [(options === null || options === void 0 ? void 0 : options.length) === 0 && createable && trimmedText && !loading && (jsxRuntime.jsxs("li", Object.assign({ className: "reaselct-menu-create-option", onClick: event => {
                          event.preventDefault();
                          event.stopPropagation();
                          onSelectedChange({
                              value: trimmedText.toLowerCase(),
                              children: trimmedText.toLowerCase()
                          });
                      } }, { children: ["Create option \"", trimmedText.toLowerCase(), "\""] }), void 0)), (options === null || options === void 0 ? void 0 : options.length) === 0 &&
                      !createable &&
                      filterable &&
                      trimmedText &&
                      !loading && (jsxRuntime.jsxs("li", Object.assign({ className: "reaselct-menu-empty-search" }, { children: ["No option(s) for \"", trimmedText, "\""] }), void 0)), (options === null || options === void 0 ? void 0 : options.length) === 0 &&
                      !createable &&
                      filterable &&
                      !trimmedText &&
                      !loading && (jsxRuntime.jsx("li", Object.assign({ className: "reaselct-menu-empty" }, { children: "No option(s) available" }), void 0)), groups.hasGroups
                      ? groups.groups.map(g => (jsxRuntime.jsx(react.Fragment, { children: g.name === 'undefined' ? (renderListItems(g.items, g)) : (jsxRuntime.jsxs("li", Object.assign({ className: classNames__default["default"](css.groupItem, 'reaselct-menu-group') }, { children: [jsxRuntime.jsx("h3", Object.assign({ className: "reaselct-menu-group-header" }, { children: g.name }), void 0), jsxRuntime.jsx("ul", { children: renderListItems(g.items, g) }, void 0)] }), void 0)) }, g.name)))
                      : renderListItems(options)] }, void 0) }), void 0));
  };

  const useWidth = (ref, overlayRef) => {
      const [menuWidth, setMenuWidth] = react.useState(0);
      const updateWidthInternal = react.useCallback(() => {
          if (ref === null || ref === void 0 ? void 0 : ref.current) {
              const { width } = ref.current.getBoundingClientRect();
              if (width !== menuWidth) {
                  setMenuWidth(width);
                  return true;
              }
          }
      }, [ref, menuWidth]);
      react.useEffect(() => {
          updateWidthInternal();
      }, [updateWidthInternal]);
      react.useEffect(() => {
          window.addEventListener('resize', updateWidthInternal);
          return () => window.removeEventListener('resize', updateWidthInternal);
      }, [updateWidthInternal]);
      const updateWidth = react.useCallback(() => {
          var _a;
          if (updateWidthInternal()) {
              // trigger event so position is updated
              (_a = overlayRef.current) === null || _a === void 0 ? void 0 : _a.updatePosition();
          }
      }, [updateWidthInternal, overlayRef]);
      return [menuWidth, updateWidth];
  };

  function getGroups(options) {
      if (!(options === null || options === void 0 ? void 0 : options.length)) {
          return {
              groups: [],
              itemsCount: 0,
              hasGroups: false
          };
      }
      const groupsMap = groupBy__default["default"](options, t => t.group);
      const groupNames = Object.keys(groupsMap);
      if (groupNames.length === 1 && groupNames[0] === 'undefined') {
          return {
              groups: [],
              itemsCount: options.length,
              hasGroups: false
          };
      }
      let index = 0;
      const groups = Object.entries(groupsMap).map(([key, value], index) => ({
          offset: 0,
          index,
          items: value,
          name: key
      }));
      for (const group of groups) {
          group.offset = index;
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          for (const _item of group.items) {
              index++;
          }
      }
      return {
          groups,
          itemsCount: (groups === null || groups === void 0 ? void 0 : groups.length) !== 0
              ? sumBy__default["default"](groups, g => g.items.length)
              : options.length,
          hasGroups: (groups === null || groups === void 0 ? void 0 : groups.length) !== 0
      };
  }

  const SelectOption = ({ children }) => children;

  function createOptions(children) {
      const arr = react.Children.toArray(children);
      return arr
          .filter((child) => { var _a; return ((_a = child.type) === null || _a === void 0 ? void 0 : _a.name) === SelectOption.name; })
          .map((child) => child.props);
  }

  const Select = ({ id, name, autoFocus, clearable, filterable, menuPlacement, closeOnSelect, menuDisabled, refreshable, placeholder, disabled, createable, loading, multiple, error, className, children, value, required, input, menu, onRefresh, onChange, onBlur: onInputBlur, onFocus: onInputFocus, onInputKeydown, onInputKeyUp, onOptionsChange, onInputChange }) => {
      var _a, _b;
      const overlayRef = react.useRef(null);
      const inputRef = react.useRef(null);
      const [internalValue, setInternalValue] = react.useState(value);
      const [open, setOpen] = react.useState(false);
      const [index, setIndex] = react.useState(-1);
      const internalId = rdk.useId(id);
      const [menuWidth, updateMenuWidth] = useWidth((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.containerRef, overlayRef);
      const [options, setOptions] = react.useState(createOptions(children));
      react.useEffect(() => {
          const opts = createOptions(children);
          if (!isEqual__default["default"](opts, options)) {
              setOptions(opts);
          }
      }, [children, options]);
      const { result, keyword, search, resetSearch } = reactUseFuzzy.useFuzzy(options, {
          keys: ['children', 'group']
      });
      const groups = react.useMemo(() => getGroups(result), [result]);
      const selectedOption = react.useMemo(() => {
          if (multiple) {
              if (internalValue || internalValue === '') {
                  return options.filter(o => internalValue.includes(o.value));
              }
              return [];
          }
          else if (internalValue || internalValue === '') {
              return options.find(o => o.value === internalValue);
          }
          return null;
      }, [options, multiple, internalValue]);
      react.useLayoutEffect(() => {
          updateMenuWidth();
      }, [internalValue, updateMenuWidth]);
      react.useEffect(() => {
          // This is needed to alllow a select to have a
          // starting variable that is set from state
          if (!isEqual__default["default"](value, internalValue)) {
              setInternalValue(value);
          }
      }, [value, internalValue]);
      react.useEffect(() => {
          if (internalValue && createable) {
              if (multiple) {
                  for (const v of internalValue) {
                      const newOptions = [];
                      const has = options.find(o => o.value === v);
                      if (!has) {
                          newOptions.push({
                              children: v,
                              value: v
                          });
                      }
                      if (newOptions.length) {
                          const updatedOptions = [...options, ...newOptions];
                          onOptionsChange === null || onOptionsChange === void 0 ? void 0 : onOptionsChange(updatedOptions);
                      }
                  }
              }
              else {
                  const has = options.find(o => o.value === internalValue);
                  if (!has) {
                      const updatedOptions = [
                          ...options,
                          {
                              children: internalValue,
                              value: internalValue
                          }
                      ];
                      onOptionsChange === null || onOptionsChange === void 0 ? void 0 : onOptionsChange(updatedOptions);
                  }
              }
          }
      }, [createable, internalValue, multiple, options, onOptionsChange]);
      const resetInput = react.useCallback(() => {
          setIndex(-1);
          resetSearch();
      }, [resetSearch]);
      const resetSelect = react.useCallback(() => {
          setOpen(false);
          resetInput();
      }, [resetInput]);
      const onArrowUpKeyUp = react.useCallback((event) => {
          event.preventDefault();
          setIndex(Math.max(index - 1, -1));
      }, [index]);
      const onArrowDownKeyUp = react.useCallback((event) => {
          event.preventDefault();
          setIndex(Math.min(index + 1, groups.itemsCount - 1));
      }, [groups.itemsCount, index]);
      const onInputFocused = react.useCallback((event) => {
          if (!disabled && !menuDisabled) {
              setOpen(true);
          }
          onInputFocus === null || onInputFocus === void 0 ? void 0 : onInputFocus(event);
      }, [disabled, menuDisabled, onInputFocus]);
      const onInputExpanded = react.useCallback((event) => {
          event.stopPropagation();
          if (!disabled && !menuDisabled) {
              setOpen(!open);
          }
      }, [disabled, menuDisabled, open]);
      const onInputChanged = react.useCallback((event) => {
          const value = event.target.value;
          search(value);
          onInputChange === null || onInputChange === void 0 ? void 0 : onInputChange(event);
      }, [onInputChange, search]);
      const toggleSelectedMultiOption = react.useCallback((selections) => {
          const newOptions = [];
          let newSelectedOptions = selectedOption;
          if (!selections) {
              newSelectedOptions = [];
          }
          else {
              if (!Array.isArray(selections)) {
                  selections = [selections];
              }
              for (const next of selections) {
                  const hasOption = options.find(o => o.value === next.value);
                  const has = (internalValue || []).includes(next.value);
                  if (has) {
                      newSelectedOptions = newSelectedOptions.filter(o => o.value !== next.value);
                  }
                  else {
                      newSelectedOptions = [...newSelectedOptions, next];
                  }
                  if (!hasOption && createable) {
                      newOptions.push(next);
                  }
              }
          }
          return {
              newValue: newSelectedOptions.map(o => o.value),
              newSelectedOptions,
              newOptions
          };
      }, [createable, internalValue, options, selectedOption]);
      const toggleSelectedOption = react.useCallback((option) => {
          var _a;
          let newValue;
          if (multiple) {
              const result = toggleSelectedMultiOption(option);
              newValue = result.newValue;
              if ((_a = result.newOptions) === null || _a === void 0 ? void 0 : _a.length) {
                  onOptionsChange === null || onOptionsChange === void 0 ? void 0 : onOptionsChange([...options, ...result.newOptions]);
              }
              if (closeOnSelect) {
                  setOpen(false);
              }
          }
          else {
              const singleOption = option;
              const hasOption = options.find(o => o.value === (singleOption === null || singleOption === void 0 ? void 0 : singleOption.value));
              newValue = singleOption === null || singleOption === void 0 ? void 0 : singleOption.value;
              const hasValue = newValue !== undefined && newValue !== null;
              if (createable && !hasOption && hasValue) {
                  onOptionsChange === null || onOptionsChange === void 0 ? void 0 : onOptionsChange([...options, singleOption]);
              }
              if (closeOnSelect && hasOption) {
                  setOpen(false);
              }
          }
          setInternalValue(newValue);
          resetInput();
          onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
      }, [
          closeOnSelect,
          createable,
          multiple,
          onChange,
          onOptionsChange,
          options,
          resetInput,
          toggleSelectedMultiOption
      ]);
      const onEnterKeyUp = react.useCallback((event) => {
          var _a, _b;
          const inputElement = event.target;
          const inputValue = inputElement.value.trim().toLowerCase();
          if (index === -1 && createable && !inputValue) {
              return;
          }
          if (index > -1 || createable) {
              const newSelection = {
                  value: createable ? (_a = result[index]) === null || _a === void 0 ? void 0 : _a.value : inputValue,
                  children: createable ? (_b = result[index]) === null || _b === void 0 ? void 0 : _b.value : inputValue,
              };
              toggleSelectedOption(newSelection);
          }
      }, [createable, index, result, toggleSelectedOption]);
      const onInputKeyedUp = react.useCallback((event) => {
          const key = event.key;
          if (key === 'ArrowUp') {
              onArrowUpKeyUp(event);
          }
          else if (key === 'ArrowDown') {
              onArrowDownKeyUp(event);
          }
          else if (key === 'Escape') {
              resetSelect();
          }
          else if (key === 'Enter' || key === 'Tab') {
              onEnterKeyUp(event);
          }
          onInputKeyUp === null || onInputKeyUp === void 0 ? void 0 : onInputKeyUp(event);
      }, [onArrowDownKeyUp, onArrowUpKeyUp, onEnterKeyUp, onInputKeyUp, resetSelect]);
      const onInputBlured = react.useCallback((event) => {
          const inputElement = event.target;
          const inputValue = inputElement.value.trim();
          if (menuDisabled && createable && inputValue) {
              const newSelection = {
                  value: inputValue,
                  children: inputValue
              };
              toggleSelectedOption(newSelection);
          }
          onInputBlur === null || onInputBlur === void 0 ? void 0 : onInputBlur(event);
      }, [createable, menuDisabled, onInputBlur, toggleSelectedOption]);
      const onMenuSelectedChange = react.useCallback((option) => {
          var _a;
          toggleSelectedOption(option);
          if (closeOnSelect) {
              setOpen(false);
          }
          else {
              (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
          }
      }, [closeOnSelect, toggleSelectedOption]);
      const onOverlayClose = react.useCallback(() => {
          const inputValue = keyword.trim();
          if (createable && inputValue) {
              const newSelection = {
                  value: inputValue,
                  children: inputValue
              };
              toggleSelectedOption(newSelection);
          }
          resetSelect();
      }, [createable, keyword, resetSelect, toggleSelectedOption]);
      return (jsxRuntime.jsx(rdk.ConnectedOverlay, Object.assign({ open: open, closeOnBodyClick: true, closeOnEscape: true, appendToBody: true, placement: menuPlacement, reference: (_b = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _b === void 0 ? void 0 : _b.containerRef, ref: overlayRef, onClose: onOverlayClose, content: () => (jsxRuntime.jsx(rdk.CloneElement, { element: menu, id: `${internalId}-menu`, style: { width: menuWidth }, selectedOption: selectedOption, createable: createable, disabled: disabled, options: result, groups: groups, index: index, multiple: multiple, inputSearchText: keyword, loading: loading, filterable: filterable, onSelectedChange: onMenuSelectedChange }, void 0)) }, { children: jsxRuntime.jsx(rdk.CloneElement, { element: input, id: `${internalId}-input`, name: name, disabled: disabled, reference: inputRef, menuOpen: open, autoFocus: autoFocus, options: options, error: error, closeOnSelect: closeOnSelect, inputText: keyword, multiple: multiple, createable: createable, filterable: filterable, refreshable: refreshable, className: className, required: required, loading: loading, placeholder: placeholder, selectedOption: selectedOption, clearable: clearable, menuDisabled: menuDisabled, onSelectedChange: toggleSelectedOption, onExpandClick: onInputExpanded, onKeyDown: onInputKeydown, onKeyUp: onInputKeyedUp, onInputChange: onInputChanged, onBlur: onInputBlured, onFocus: onInputFocused, onRefresh: onRefresh }, void 0) }), void 0));
  };
  Select.defaultProps = {
      clearable: true,
      filterable: true,
      menuPlacement: 'bottom-start',
      closeOnSelect: true,
      menuDisabled: false,
      refreshable: false,
      input: jsxRuntime.jsx(SelectInput, {}, void 0),
      menu: jsxRuntime.jsx(SelectMenu, {}, void 0)
  };

  exports.CloseIcon = CloseIcon;
  exports.DownArrowIcon = DownArrowIcon;
  exports.LoadingIcon = LoadingIcon;
  exports.RefreshIcon = RefreshIcon;
  exports.Select = Select;
  exports.SelectInput = SelectInput;
  exports.SelectInputChip = SelectInputChip;
  exports.SelectMenu = SelectMenu;
  exports.SelectOption = SelectOption;
  exports.createOptions = createOptions;
  exports.getGroups = getGroups;
  exports.useWidth = useWidth;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
